/* Copyright (C) 2001 Neal H Walfield

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#undef random
#undef srandom
#define _GNU_SOURCE

#include <error.h>
#include <stdio.h>
#include <stdarg.h>
#include <assert.h>
#include <hurd.h>
#include <hurd/process.h>

/* Emulate BSD's setproctitle by diddling the contents of argv.  */
void
setproctitle(const char *fmt, ...)
{
  error_t err;
  static char *title;
  vm_address_t argv, envp;
  va_list ap;
  char *local;
  char *tmp;

  err = proc_get_arg_locations (mach_task_self (), &argv, &envp);
  if (err)
    return;

  va_start (ap, fmt);
  vasprintf (&local, fmt, ap);
  va_end (ap);

  tmp = realloc (title, strlen (local) + 1);
  assert (tmp);
  title = tmp;

  ((char **)argv)[0] = title;
}

